#include <stdio.h>
#include <string.h>
#include <malloc.h>
//для открытия файла + флаги для этого
#include <sys/stat.h>
#include <fcntl.h>
//для чтения
#include <unistd.h>
//для exit
#include <stdlib.h>

#include "QuadEq.c"

/*https://jakeroid.com/ru/blog/sistemnyie-vyizovyi-dlya-rabotyi-s-faylami-v-linux/ */
QuadraticEquation* readInputFile(char* nameFile)
{
    QuadraticEquation* equation = malloc(sizeof(QuadraticEquation));
    //открытие дескрипторп
    int fileHandle = open(nameFile, O_RDONLY, S_IRUSR | S_IROTH);
    if(fileHandle == -1)
    {
        printf("Файла с иходными данными не существует. Создайте файл %s \n", nameFile);
		exit(ERROR_OPEN_FILE);
    }

//чтение файла
    char* buffer = malloc(BUFFER);
//memset(buff, 0, 64); //Заполняю буфер нулями
    int countRead = 0;
    countRead = read(fileHandle, buffer, BUFFER);
    if (countRead == 0)
	{
		printf("Файла с иходными данными пуст.\n");
		exit(ERROR_INPUT_DATA);
	}

//чтеные данных из файла
    int resultReadData = sscanf(buffer, "%lf %lf %lf", &equation->a, &equation->b, &equation->c);
    if (resultReadData == 0)
	{
		printf("Не удалось корректно прочитать файл.\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a == 0 && equation->b == 0 && equation->c == 0)
	{
		printf("Все коэфициенты равны 0. Проверьте исходный файл.\n");
		exit(ERROR_READ_DATA);
	}
	if (equation->a == 0)
	{
		printf("Коэффициент а равен 0. Это не квадратное уравнение.\n");
		exit(ERROR_READ_DATA);
	}

    close(fileHandle);
    return equation;
}

void writeOutputFile(QuadraticEquation equation, char* nameFile)
{
	int fileHandle = open(nameFile,  O_WRONLY | O_CREAT, S_IRWXO | S_IRWXU);
	if(fileHandle == -1)
    {
        printf("Что-то пошло не так при открытии файла.\n");
		exit(ERROR_OPEN_FILE);
    }
	
	char* stringIn[6];
	for (size_t i = 0; i < 6; i++)
	{
		stringIn[i] = calloc(BUFFER, 1);
	}
	stringIn[0] = "Это решение файлами в си.\n";
	sprintf(stringIn[1], "Уравнение: %.3lf * x^2 + (%.3lf) * x + (%.3lf) = 0\n", equation.a, equation.b, equation.c);
	sprintf(stringIn[2], "Дискриминант = %.3lf\n", equation.discriminant);
	char* result = calloc(2000, 1);
	if (equation.countRoot == 0)
	{
		sprintf(stringIn[3], "Корней нет.\n");
		sprintf(result, "%s%s%s%s", stringIn[0], stringIn[1], stringIn[2], stringIn[3]);
		//printf("%s", result);
	}
	else if (equation.countRoot == 1)
	{
		sprintf(stringIn[3], "Уравнение имеет одно решение:\n");
		sprintf(stringIn[4], "x = %.3lf\n", equation.x1);
		sprintf(result, "%s%s%s%s%s", stringIn[0], stringIn[1], stringIn[2], stringIn[3], stringIn[4]);
		//printf("%s", result);
	}
	else if (equation.countRoot == 2)
	{
		sprintf(stringIn[3], "Уравнение имеет два решения:\n");
		sprintf(stringIn[4], "x1 = %.3lf\n", equation.x1);
		sprintf(stringIn[5], "x2 = %.3lf\n", equation.x2);
		sprintf(result, "%s%s%s%s%s%s", stringIn[0], stringIn[1], stringIn[2], stringIn[3], stringIn[4], stringIn[5]);
		//printf("%s", result);
	}
	else
	{
		printf("Что-то пошло не так при решении уравнений.");
		exit(ERROR_WRITE_DATA);
	}
	/*Запись данных в файл.*/
	int resWrite = write(fileHandle, result, strlen(result));
	if (resWrite == -1)
	{
		printf("Ошибка записи файла.\n");
		exit(ERROR_WRITE_DATA);
	}
	
	close(fileHandle);
	//printf("Решение записано в файл %s\n", FILE_OUT);

}

int startWorkWithFile()
{
    QuadraticEquation* equation = readInputFile(FILE_IN);
    solutionQuadraticEquation(equation);
	writeOutputFile(*equation, FILE_OUT);

    return 0;
}